class MyKNN:

    def __init__(self, k=3, is_classification=True, distance_name='Euclidean'): # __init__ is the constructor function in python.
        # When, later on in your code, you create an object with "variable = KNN(), this function is called"
        self.k = k
        self.distance_name = distance_name
        self.is_classification = is_classification

        # initializing a variable to store the values of the X and y that will be fitted to the model.
        # Remember: KNN does not have to train the model, just store their values. Use these variables to do that
        self.X = None 
        self.y = None

    def _compute_distance(self, x1, x2, distance_name='Euclidean Distance'):
        # Here you will implement your distance function ie. Euclidean distance. Complete the code below
        if distance_name == 'Euclidean':
            distance = # implement the formula for Euclidean Distance -> https://docs.scipy.org/doc/scipy/reference/generated/scipy.spatial.distance.euclidean.html#scipy.spatial.distance.euclidean
            
        if distance_name == 'Manhattan': # you can change this for other kinds of distances
            distance = # implement the formula for Manhattan Distance here
        
        return distance

    def fit(self, X, y):
        # Remember, you do not have to train a model for KNN, but mainly store the variables. Complete the code below
        self.X = 
        self.y =
    
    def predict(self, x):
        # For this exercise, we will do the prediction for a single instance.
        # x here is just a single instance.
        
        distances = []
        # Complete this part of the code. 
        
        # Step 1: You will compare the distance of x to each other instance in your training data.  
        # Use the function implemented in _compute_distances. Complete code below
        
        
        # Step 2: Now that you have the distances, we get the labels of each one of the k-nearest instances.
        index_of_nearest_neighbors = np.argsort(distances)[:self.k]
        
        # From the index, you should get the corresponding labels to make the prediction. Complete code below
        
        
        #Step 3: Make the prediction 
        if self.is_classification:
            return # For classification, you will return the most common class among the nearest neighbors
        else:
            return # For regression, you will return the mean of the values of the nearest neighbors
        
